module Init.Size (
         Size,
         sizeFromInt,
         intFromSize
       ) where


{-

Siin defineeritakse laevasuurusetp  Size  ja vajalikud teisendused.

-}


import Init.Constants


newtype Size
  = Size Int
  deriving (Eq, Ord)


-- Tisarvu teisendamine lubatud laevasuuruseks.
sizeFromInt
  :: Int -> Maybe Size
sizeFromInt x
  = if fromEnum (minBound :: Size) <= x && x <= fromEnum (maxBound :: Size)
       then Just (Size x)
       else Nothing

-- Laevasuurusest tisarvu tegemine.
intFromSize
  :: Size -> Int
intFromSize (Size n)
  = n


{- Size  saab klasside  Bounded  ja  Enum  esindajaks. -}

instance Bounded Size where

  minBound
    = Size minSize

  maxBound
    = Size maxSize


instance Enum Size where

  toEnum x
    = case sizeFromInt x of
        Just s
          -> s
        _
          -> error ("Can't interpret  " ++ show x ++ "  as size of a ship")

  fromEnum
    = intFromSize

