module Init.SizeDistr (
         SizeDistr,
         distrFromSizeList,
         sizeListFromDistr,
         deleteFromSizeDistr
       ) where


{-

Siin defineeritakse laevasuurusteks jaotuse tp  SizeDistr  ja seonduvad
teisendused.

-}


import Data.List
import Utils
import Init.Constants
import Init.Size


newtype SizeDistr
  = Distr [Size]
  deriving (Eq)


-- Suuruste listi teisendamine lubatud laevasuurusteks jaotuseks.
distrFromSizeList
  :: [Size] -> Maybe SizeDistr
distrFromSizeList ss
  = if sum (map intFromSize ss) <= maxSizeSum
       then Just (Distr (sort ss))
       else Nothing

-- Laevasuurusteks jaotuse esitamine suuruste listina.
sizeListFromDistr
  :: SizeDistr -> [Size]
sizeListFromDistr (Distr ss)
  = ss

-- Laevasuurusteks jaotusest he laevasuuruse eemaldamine.
deleteFromSizeDistr
  :: Size -> SizeDistr -> SizeDistr
deleteFromSizeDistr s (Distr ss)
  = Distr (deleteFromSorted s ss)

